import {Component, inject, input, InputSignal, OnInit} from '@angular/core';
import {FormBuilder, FormGroup, ReactiveFormsModule, Validators} from "@angular/forms";
import {GetTask} from "../dto/models";
import {TodoService} from "../service/todo.service";
import {assert} from "@angular/compiler-cli/linker";

@Component({
  selector: 'app-edit',
  imports: [
    ReactiveFormsModule
  ],
  templateUrl: './edit.component.html',
  styleUrl: './edit.component.css'
})
export default class EditComponent implements OnInit{
  private fb: FormBuilder = inject(FormBuilder);
  private todoService: TodoService = inject(TodoService);
  public form!: FormGroup;
  public todo: InputSignal<GetTask|null> = input<GetTask|null>(null);

  ngOnInit() {
    this.form = this.fb.group({
      title: [this.todo()?.title, Validators.required],
      dueDate: [this.todo()?.dueDate, Validators.required],
    });
  }

  edit() {
    this.todoService.edit(this.form.value, this.todo()?.id ?? 0)
  }
}
